Data <- read.csv("ensyu_cleaningall_edit3.csv",header=T)

Data$prosperity <- 2*(Data$lsl*Data$gbvpx*Data$Sn)/10000
Data$transcost <- (Data$SRXg-Data$xORXg)
Data$male <- Data$dummy

library(lme4)

res <- glmer(Sdummy ~ 0 + prosperity + transcost + male, family = binomial, data = Data)
summary(res)
source("probcalc_ranef.r")

for(i in 1:10000){
  c0 <- ranef(res)$j
  c0$j <- as.numeric(rownames(c0))
  colnames(c0) <- c("ranef","j")
  Data <- merge(Data, c0, by = "j", all.x = TRUE)
  b0 <- fixef(res)
  Data$TEP <- probcalc(b0) # TEP: Tentative estimated probability
  NTmean <- tapply(Data$TEP,Data$j,mean)
  meandata <- data.frame(NTmean)
  meandata$Z <- as.numeric(rownames(meandata))
  Data <- merge(Data, meandata, by = "j", all.x = TRUE)
  Data$n <- as.numeric(Data$NTmean)
  Data$miryoku <- 2*(Data$lsl*Data$gbvpx*Data$Sn)/10000  
  res <- glmer(Sdummy ~ 0 + prosperity + transcost + male,
               family = binomial,data=Data)
  print(b1 <- fixef(res))
  bdif <- abs(b1-b0)  
  Data$ranef <- NULL
  Data$NTmean <- NULL
  if (max(bdif)<0.0000001) break
}

summary(res)
logLik(res)


